/* defaults.h: The ircd defaults header.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_defaults_h
/* only included at end of config.h to supply defaults */
#define INCLUDED_defaults_h

/* set other fd limits based on values from user */
#ifndef HARD_FDLIMIT_
#error HARD_FDLIMIT_ undefined
#endif
#define HARD_FDLIMIT   (HARD_FDLIMIT_ - 10)
#define MAXCONNECTIONS HARD_FDLIMIT
#define MASTER_MAX     (HARD_FDLIMIT - MAX_BUFFER)
/* class {} default values */
#define DEFAULT_SENDQ            15000000 /* default max SendQ */
#define PORTNUM                  6667 /* default outgoing portnum */
#define DEFAULT_PINGFREQUENCY    120 /* ping frequency */
#define DEFAULT_CONNECTFREQUENCY 600 /* connect frequency */
#define TS_MAX_DELTA_MIN         10 /* min value for ts_max_delta */
#define TS_MAX_DELTA_DEFAULT     600 /* ts_max_delta */
#define TS_WARN_DELTA_MIN        10 /* min value for ts_warn_delta */
#define TS_WARN_DELTA_DEFAULT    30 /* ts_warn_delta */

/* ServerInfo default values */
#define NETWORK_NAME_DEFAULT "Formatted" /* network_name */
#define NETWORK_DESC_DEFAULT "Formatted IRC Network" /* network_desc */
#define SERVER_MASK_DEFAULT  "*.formatted.net" /* mask */

/* General defaults */
#define CLIENT_FLOOD_DEFAULT 20 /* default for client_flood */
#define CLIENT_FLOOD_MAX     2000
#define CLIENT_FLOOD_MIN     10
#define LINKS_DELAY_DEFAULT  300
#define MAX_TARGETS_DEFAULT  4 /* default for max_targets */
#define INIT_LOG_LEVEL       L_NOTICE /* default for log_level */
#define IDENT_TIMEOUT        10
#define MIN_JOIN_LEAVE_TIME  60
#define MAX_JOIN_LEAVE_COUNT 25
#define OPER_SPAM_COUNTDOWN  5
#define JOIN_LEAVE_COUNT_EXPIRE_TIME 120

#if defined(DEBUGMODE) || defined(DNS_DEBUG)
#define Debug(x) debug x
#define LOGFILE LPATH
#else
#define Debug(x) ;
#define LOGFILE "/dev/null"
#endif
#define MIN_SPAM_NUM 5
#define MIN_SPAM_TIME 60
#endif /* INCLUDED_defaults_h */
