/* ircd_getopt.h: A header for the getopt() command line option calls.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef __GETOPT_H_INCLUDED__
#define __GETOPT_H_INCLUDED__

struct lgetopt {
  const char *opt; /* name of the argument */
  void *argloc; /* where we store the argument to it (-option argument) */
  enum {
    INTEGER,
    YESNO,
    STRING,
    USAGE,
    ENDEBUG
  } argtype;
  const char *desc; /* description of the argument, usage for printing help */
};

extern struct lgetopt myopts[];

void usage(char *);
void parseargs(int *, char ***, struct lgetopt *);
#endif /* __GETOPT_H_INCLUDED__ */
