/* motd.h: A header for the MOTD functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_motd_h
#define INCLUDED_motd_h
#include "ircd_defs.h"

/* XXX really, should be mallocing this on the fly but... */
#define MESSAGELINELEN 256

typedef enum {
  USER_MOTD,
  USER_LINKS,
  OPER_MOTD
} MotdType;

struct MessageFileLine {
  char line[MESSAGELINELEN + 1];
  struct MessageFileLine *next;
};
typedef struct MessageFileLine MessageFileLine;

struct MessageFile {
  char fileName[PATH_MAX + 1];
  MotdType motdType;
  MessageFileLine *contentsOfFile;
  char lastChangedDate[MAX_DATE_STRING + 1];
};
typedef struct MessageFile MessageFile;

struct Client;

void InitMessageFile(MotdType, const char *, struct MessageFile *);
int SendMessageFile(struct Client *, struct MessageFile *);
int ReadMessageFile(MessageFile *);
#endif /* INCLUDED_motd_h */
