/* parse.h: A header for the message parser.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_parse_h_h
#define INCLUDED_parse_h_h
#define MAX_MSG_HASH 387

struct Message;
struct Client;

struct MessageHash {
  char *cmd;
  struct Message *msg;
  struct MessageHash *next;
};

extern void parse(struct Client *, char *, char *);
extern void clear_hash_parse(void);
extern void mod_add_cmd(struct Message * msg);
extern void mod_del_cmd(struct Message * msg);
extern void report_messages(struct Client *);
extern void handle_encap(struct Client *, struct Client *, const char *, int,
  char *parv[]);
#endif /* INCLUDED_parse_h_h */
