/* res.h: A header with the DNS functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef _RES_H_INCLUDED
#define _RES_H_INCLUDED 1

#include "config.h"
#include "ircd_defs.h"
#include "fileio.h"
#include "adns.h"

#define DNS_BLOCK_SIZE 64

struct DNSQuery {
  void *ptr;
  adns_query query;
  adns_answer answer;
  void (*callback) (void *vptr, adns_answer * reply);
};

void init_resolver(void);
void restart_resolver(void);
void timeout_adns(void *);
int adns_gethost(const char *name, int aftype, struct DNSQuery * req);
int adns_getaddr(struct irc_inaddr * addr, int aftype, struct DNSQuery * req,
  int arpa_type);
void delete_adns_queries(struct DNSQuery * q);
void report_adns_servers(struct Client *);
#endif
