/* resv.h: A header for the reservation (jupe) functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_resv_h
#define INCLUDED_resv_h

#define RESV_CHANNEL  0x0001
#define RESV_NICK     0x0002
#define RESV_NICKWILD 0x0004

struct ResvEntry {
  char *name;
  char *reason;
  int flags;
};

extern dlink_list resv_channel_list;
extern dlink_list resv_nick_list;

extern struct ResvEntry *create_resv(char *, char *, int);

extern int delete_resv(struct ResvEntry *);
extern void clear_resv(void);

extern int find_channel_resv(const char *);
extern int find_nick_resv(char *);
extern struct ResvEntry *get_nick_resv(char *);

extern void report_resv(struct Client *);

extern int clean_resv_nick(char *);
extern int valid_wild_card_simple(const char *);
#endif /* INCLUDED_hash_h */
