/* rsa.h: A header for the RSA functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_rsa_h
#define INCLUDED_rsa_h 1

#ifdef HAVE_LIBCRYPTO
extern void report_crypto_errors(void);
extern int verify_private_key(void);
extern int generate_challenge(char **r_challenge, char **r_response,
  RSA * key);
extern int crypt_data(char **out, char *in, int len, char *key);
extern int decrypt_data(char **out, char *in, int len, char *key);
extern int get_randomness(unsigned char *buf, int length);
#endif

#endif /* INCLUDED_rsa_h */
