/* s_conf.h: A header for the debug functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_debug_h
#define INCLUDED_s_debug_h

struct Client;
/* defined debugging levels */
#define DEBUG_FATAL  0
#define DEBUG_ERROR  1 /* report_error() and other errors that are found */
#define DEBUG_NOTICE 3
#define DEBUG_DNS    4 /* used by all DNS related routines */
#define DEBUG_INFO   5 /* general useful info */
#define DEBUG_NUM    6 /* numerics */
#define DEBUG_SEND   7 /* everything that is sent out */
#define DEBUG_DEBUG  8 /* anything to do with debugging */
#define DEBUG_MALLOC 9 /* malloc/free calls */
#define DEBUG_LIST   10 /* debug list use */

extern void send_usage(struct Client *);
extern void count_memory(struct Client *);

extern void debug(int, char *,...);
#endif /* INCLUDED_s_debug_h */
