/* s_gline.h: A header for the gline functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_gline_h
#define INCLUDED_s_gline_h

#include "config.h"
#include "ircd_defs.h"

struct Client;
struct ConfItem;

extern struct ConfItem *find_is_glined(const char *host, const char *name);
extern void cleanup_glines();
extern void add_gline(struct ConfItem *);

typedef struct gline_pending {
  char oper_nick1[NICKLEN + 1];
  char oper_user1[USERLEN + 1];
  char oper_host1[HOSTLEN + 1];
  const char *oper_server1; /* point to scache */
  char *reason1;
  time_t time_request1;

  char oper_nick2[NICKLEN + 1];
  char oper_user2[USERLEN + 1];
  char oper_host2[HOSTLEN + 1];
  const char *oper_server2; /* point to scache */
  char *reason2;
  time_t time_request2;

  time_t last_gline_time; /* for expiring entry */
  char user[USERLEN + 1];
  char host[HOSTLEN + 1];
} gline_pending_t;

/* expiry for pending G-Lines in seconds */
#define GLINE_PENDING_EXPIRE 600
#define CLEANUP_GLINES_TIME  300

dlink_list pending_glines;
extern dlink_list glines;
#endif
