/* s_misc.h: A header for the miscellaneous functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_misc_h
#define INCLUDED_s_misc_h

struct Client;
struct ConfItem;

extern char *date(time_t);
extern const char *smalldate(time_t);
extern char *small_file_date(time_t);

/* 1024^n = 1024, 1048576, 1073741824 */
#define _GMKs(x) (((x) > 1073741824) ? "Terabytes" : (((x) > 1048576) ? \
                 "Gigabytes" : (((x) > 1024) ? "Megabytes" : "Kilobytes")))
#define _GMKv(x) (((x) > 1073741824) ? (float)((x)/1073741824) : (((x) > \
                 1048576) ? (float)((x)/1048576) : (((x) > 1024) ? \
                 (float)((x)/1024) : (float)(x))))
#endif
