/* s_stats.h: A header for the statistics functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_stats_h
#define INCLUDED_s_stats_h

#include "config.h"

struct Client;
/* statistics structures */
struct ServerStatistics {
  unsigned int is_cl; /* number of client connections */
  unsigned int is_sv; /* number of server connections */
  unsigned int is_ni; /* connection but no idea who it was */
  unsigned short is_cbs; /* bytes sent to clients */
  unsigned short is_cbr; /* bytes received to clients */
  unsigned short is_sbs; /* bytes sent to servers */
  unsigned short is_sbr; /* bytes received to servers */
  unsigned long is_cks; /* k-bytes sent to clients */
  unsigned long is_ckr; /* k-bytes received to clients */
  unsigned long is_sks; /* k-bytes sent to servers */
  unsigned long is_skr; /* k-bytes received to servers */
  time_t is_cti; /* time spent connected by clients */
  time_t is_sti; /* time spent connected by servers */
  unsigned int is_ac; /* connections accepted */
  unsigned int is_ref; /* accepts refused */
  unsigned int is_unco; /* unknown commands */
  unsigned int is_wrdi; /* command going in wrong direction */
  unsigned int is_unpf; /* unknown prefix */
  unsigned int is_empt; /* empty message */
  unsigned int is_num; /* numeric message */
  unsigned int is_kill; /* number of kills generated on collisions */
  unsigned int is_asuc; /* successful auth requests */
  unsigned int is_abad; /* bad auth requests */
};
extern struct ServerStatistics *ServerStats;

extern void init_stats(void);
extern void tstats(struct Client * client);
#endif /* INCLUDED_s_stats_h */
