/* s_user.h: A header for the user functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_user_h
#define INCLUDED_s_user_h

#include "config.h"

struct Client;
extern time_t LastUsedWallops;

extern int valid_hostname(const char *hostname);
extern int valid_username(const char *username);

extern int user_mode(struct Client *, struct Client *, int, char **);
extern void send_umode(struct Client *, struct Client *, int, int, char *);
extern void send_umode_out(struct Client *, struct Client *, int);
extern int show_lusers(struct Client * source_p);
extern int register_local_user(struct Client *, struct Client *, char *,
  char *);
extern int register_remote_user(struct Client *, struct Client *, char *,
  char *);
extern int do_local_user(char *, struct Client *, struct Client *, char *,
  char *, char *, char *);
extern int do_remote_user(char *, struct Client *, struct Client *, char *,
  char *, char *, char *);

extern int user_modes_from_c_to_bitmask[];
extern void show_isupport(struct Client *);
#endif
