/* s_zip.h: A header for the compression functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_s_zip_h
#define INCLUDED_s_zip_h

#include "config.h" /* config settings */

struct Client;
#define ZIP_MINIMUM 4096 /* minimum amount of data to trigger compression */
#define ZIP_MAXIMUM 8192 /* maximum data to be compressed (DON'T CHANGE) */

struct Zdata {
  z_stream *in; /* input zip stream data */
  z_stream *out; /* output zip stream data */
  char inbuf[ZIP_MAXIMUM]; /* incoming zipped buffer */
  char outbuf[ZIP_MAXIMUM]; /* outgoing (unzipped) buffer */
  int incount; /* size of inbuf content */
  int outcount; /* size of outbuf content */
};
extern int zip_init(struct Client *);
extern void zip_free(struct Client *);
extern char *unzip_packet(struct Client *, char *, int *);
extern char *zip_buffer(struct Client *, char *, int *, int);
#endif /* INCLUDED_s_zip_h */
