/* sprintf_irc.h: The irc sprintf header.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef SPRINTF_IRC
#define SPRINTF_IRC

#include <stdarg.h>
#include "client.h"

extern int irc_vsprintf(struct Client *, char *, const char *, va_list ap);
#ifdef __GNUC__
extern int ircsprintf(char *, const char *,...)__attribute__((format(printf,
  2, 3)));
extern int irc_sprintf(struct Client *, char *, const char *,...)__attribute__(
  (format(printf, 3, 4)));
#else
extern int ircsprintf(char *str, const char *format,...);
extern int irc_sprintf(struct Client *, char *, const char *,...);
#endif

#endif /* SPRINTF_IRC */
