/* supported.h: header for supported options
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_supported_h
#define INCLUDED_supported_h

#include "config.h"
#include "channel.h"
#include "ircd_defs.h"

#ifndef USE_ASCII_CASEMAP
#define CASEMAP "rfc1459"
#else
#define CASEMAP "ascii"
#endif

#define FEATURES \
  "STD=i-d" \
  " STATUSMSG=@+" \
  "%s%s%s" \
  " MODES=%i" \
  " MAXCHANNELS=%i" \
  " MAXBANS=%i" \
  " MAXTARGETS=%i" \
  " NICKLEN=%i" \
  " TOPICLEN=%i" \
  " KICKLEN=%i"

#define FEATURESVALUES \
  ConfigChannel.use_knock ? " KNOCK" : "", \
  ConfigChannel.use_except ? " EXCEPTS" : "", \
  ConfigChannel.use_invex ? " INVEX" : "", \
  MAXMODEPARAMS, \
  ConfigChannel.max_chans_per_user, \
  ConfigChannel.max_bans, \
  ConfigFileEntry.max_targets, \
  NICKLEN-1, \
  TOPICLEN, \
  KICKLEN

#define FEATURES2 \
  "CHANTYPES=%s" \
  " PREFIX=(ov)@+" \
  " CHANMODES=%s%sb,k,l,cimnpst" \
  " NETWORK=%s" \
  " CASEMAPPING=%s" \
  " CHARSET=ascii" \
  " CALLERID" \
  " ETRACE" \
  " WALLCHOPS" \
  " SAFELIST"

#define FEATURES2VALUES \
  ConfigServerHide.disable_local_channels ? "#" : "#&", \
  ConfigChannel.use_except ? "e" : "", \
  ConfigChannel.use_invex ? "I" : "", \
  ServerInfo.network_name, \
  CASEMAP

#endif /* INCLUDED_supported_h */
