/* whowas.h: Header for the whowas functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_whowas_h
#define INCLUDED_whowas_h

#include "ircd_defs.h"
#include "client.h"

#include "setup.h"

/* Whowas hash table size */
#define WW_MAX 65536

struct User;
struct Client;
struct Whowas {
  int hashv;
  char name[NICKLEN];
  char username[USERLEN + 1];
  char hostname[HOSTLEN + 1];
  const char *servername;
  char realname[REALLEN + 1];
  time_t logoff;
  struct Client *online; /* Pointer to new nickname for chasing or NULL */
  struct Whowas *next; /* for hash table... */
  struct Whowas *prev; /* for hash table... */
  struct Whowas *cnext; /* for client struct linked list */
  struct Whowas *cprev; /* for client struct linked list */
};
extern void initwhowas(void);
/* add_history - add defined name of client to history
 * Client must be a fully registered user (specifically, the user structure must
 * have been allocated).
 */
void add_history(struct Client *, int);
/* off_history - destroys history pointers to client structures */
void off_history(struct Client *);
/* get_history - return found clients, or NULL */
struct Client *get_history(char *, time_t);
void count_whowas_memory(int *, u_long *);
/* XXX m_whowas.c in modules needs these */
extern struct Whowas WHOWAS[];
extern struct Whowas *WHOWASHASH[];
extern unsigned int hash_whowas_name(const char *name);
#endif /* INCLUDED_whowas_h */
