/* m_post.c: Exits the user if unregistered, it is a web form.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#include "stdinc.h"
#include "handlers.h"
#include "client.h"
#include "ircd.h"
#include "numeric.h"
#include "s_serv.h"
#include "send.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"
#include "s_conf.h"

static void mr_proxy(struct Client *, struct Client *, int, char **);

struct Message post_msgtab = {
  "POST", 0, 0, 0, 0, MFLG_SLOW | MFLG_UNREG, 0,
  {mr_proxy, m_registered, m_ignore, m_ignore, m_registered}
};
struct Message get_msgtab = {
  "GET", 0, 0, 0, 0, MFLG_SLOW | MFLG_UNREG, 0,
  {mr_proxy, m_registered, m_ignore, m_ignore, m_registered}
};
struct Message put_msgtab = {
  "PUT", 0, 0, 0, 0, MFLG_SLOW | MFLG_UNREG, 0,
  {mr_proxy, m_registered, m_ignore, m_ignore, m_registered}
};

#ifndef STATIC_MODULES
void _modinit(void)
{
  mod_add_cmd(&post_msgtab);
  mod_add_cmd(&get_msgtab);
  mod_add_cmd(&put_msgtab);
}
void _moddeinit(void)
{
  mod_del_cmd(&post_msgtab);
  mod_del_cmd(&get_msgtab);
  mod_del_cmd(&put_msgtab);
}
const char *_version = "1.24.2.3";
#endif

/* mr_proxy
 *  parv[0] = sender prefix
 *  parv[1] = comment
 */
static void mr_proxy(struct Client * client_p, struct Client * source_p,
  int parc, char *parv[])
{
  sendto_realops_flags(UMODE_REJ, L_ALL, "Detected HTTP Proxy connection from "
    "%s@%s", client_p->username, client_p->host);
  exit_client(client_p, source_p, source_p, "Client Exit");
}
