/* control.h: header for main servlink control mechanism
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 * Copyright (C) 2003-2004 ircd-immortal development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#ifndef INCLUDED_servlink_control_h
#define INCLUDED_servlink_control_h

#define CMD_SET_ZIP_OUT_LEVEL    1
#define CMD_START_ZIP_OUT        2
#define CMD_START_ZIP_IN         3
#define CMD_SET_CRYPT_IN_CIPHER  4
#define CMD_SET_CRYPT_IN_KEY     5
#define CMD_START_CRYPT_IN       6
#define CMD_SET_CRYPT_OUT_CIPHER 7
#define CMD_SET_CRYPT_OUT_KEY    8
#define CMD_START_CRYPT_OUT      9
#define CMD_INJECT_RECVQ         10
#define CMD_INJECT_SENDQ         11
#define CMD_INIT                 12
#define CMD_ZIPSTATS             13

#define RPL_ERROR                1
#define RPL_ZIPSTATS             2

#define COMMAND_FLAG_DATA        0x0001 /* command has data following */

struct ctrl_command {
  int command;
  int datalen;
  int gotdatalen;
  int readdata;
  unsigned char *data;
};
typedef void cmd_handler(struct ctrl_command *);
struct command_def {
  unsigned int commandid;
  cmd_handler *handler;
  unsigned int flags;
};
extern struct command_def command_table[];
#endif /* INCLUDED_servlink_control_h */
