/* numeric.c: Numeric handling functions.
 *
 * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 * Copyright (C) 1996-2002 Hybrid Development Team
 * Copyright (C) 2002      ircd-ratbox development team
 *
 * This file is licensed under the GNU General Public License, which is
 * distributed as LICENSE.
 */

#include "stdinc.h"
#include "setup.h"
#include "config.h"
#include "numeric.h"
#include "irc_string.h"
#include "common.h"
#include "memory.h"
#include "s_conf.h"
#include "messages.tab"

/* form_str
 * input  - numeric
 * output - corresponding string
 */
const char * form_str(int numeric)
{
  const char *num_ptr;
  s_assert(-1 < numeric);
  s_assert(numeric < ERR_LAST_ERR_MSG);
  s_assert(0 != replies[numeric]);
  if (numeric > ERR_LAST_ERR_MSG)
    numeric = ERR_LAST_ERR_MSG;
  if (numeric < 0)
    numeric = ERR_LAST_ERR_MSG;
  num_ptr = replies[numeric];
  if (num_ptr == NULL)
    num_ptr = replies[ERR_LAST_ERR_MSG];
  return ((const char *)num_ptr);
}
