#!/bin/sh

echo "Extracting src/version.c..."

if test -r version.c.last
then
  generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' <version.c.last`
fi
if test ! "$generation"
then
  generation=0
fi

generation=`expr $generation + 1`
platform=`uname -a`
creation=`date | \
  awk '{if (NF == 6) \
    { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
    else \
    { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 } \
  }'`

cat >version.c <<!SUB!THIS!
/*
 *  Copyright (C) 1990 Chelsea Ashley Dyerman
 *  Copyright (C) 1996-2002 Hybrid Development Team
 *  Copyright (C) 2002      ircd-ratbox development team
 *  Copyright (C) 2003-2004 ircd-immortal development team
 *
 *  This file is licensed under the GNU General Public License, which is
 *  distributed as LICENSE.
 *
 *  Note that this file is generated by version.c.SH during compile. Any
 *  changes made will disappear upon the next compilation.
 */

#include "serno.h"

const char *generation = "$generation";
const char *creation = "$creation";
const char *platform = "$platform";
const char *ircd_version = "immortal";
const char *serno = SERIALNUM;

const char *infotext[] =
{
  "As of this release, the ircd-immortal team consists of:",
  " frequency, Rachel Llorenna <frequency@formatted.net>",
  " ",
  "This Internet Relay Chat server software was based upon",
  "ircd-ratbox. For more information, please consult the",
  "CREDITS file included with ircd-immortal.",
  " ",
  "This program is free software; you can redistribute it and/or",
  "modify it under the terms of the GNU General Public License as",
  "published by the Free Software Foundation; either version 1, or",
  "(at your option) any later version.",
  " ",
  0,
};
!SUB!THIS!
