#! /bin/sh
#
# ircdchk.sh - Generates ircdchk script.
#
# You must pass the ircd prefix as parameters

echo "Extracting tools/ircdchk..."
echo "#! /bin/sh" >ircdchk
echo "#" >>ircdchk
echo "# ircdchk by frequency" >>ircdchk
echo "# This script can and should be used to detect if immortal is running. If" >>ircdchk
echo "# the ircd isn't running, it will automatically boot it up." >>ircdchk
echo "#" >>ircdchk
echo "# To check for the IRCd every 10 minutes, put the following line in your" >>ircdchk
echo "# crontab:" >>ircdchk
echo "# 0,10,20,30,40,50 * * * * ${1}/bin/ircdchk" >>ircdchk
echo "#" >>ircdchk
echo "# This should be the directory that immortal is installed in" >>ircdchk
echo "prefix=\"${1}\"" >>ircdchk
echo "#" >>ircdchk
echo "# Change this to 'no' if you want to receive status updates via E-Mail." >>ircdchk
echo "silent=\"yes\"" >>ircdchk
echo "#" >>ircdchk
echo "#################################################" >>ircdchk
echo "########## END OF CONFIGURABLE OPTIONS ##########" >>ircdchk
echo "#################################################" >>ircdchk
echo "#" >>ircdchk
echo "# If silent is specified, redirect to /dev/null to mute it." >>ircdchk
echo "if test \"\$silent\" = yes" >>ircdchk
echo "then" >>ircdchk
echo "  exec 5>/dev/null" >>ircdchk
echo "else" >>ircdchk
echo "  exec 5>&1" >>ircdchk
echo "fi" >>ircdchk
echo "#" >>ircdchk
echo "# Redirect any text thrown by the commands to output" >>ircdchk
echo "exec 1>&5" >>ircdchk
echo "exec 2>&5" >>ircdchk
echo "" >>ircdchk
echo "cd \$prefix/etc" >>ircdchk
echo "" >>ircdchk
echo "if test -r ircd.pid" >>ircdchk
echo "then" >>ircdchk
echo "# A process id file exists; but is it current?" >>ircdchk
echo "# Maybe the ircd got shutdown uncleanly..." >>ircdchk
echo "#" >>ircdchk
echo "# Get the pid from ircd.pid" >>ircdchk
echo "pid=\`cat ircd.pid\`" >>ircdchk
echo "#" >>ircdchk
echo "# Let's see if it's in our process list..." >>ircdchk
echo "running=\`ps -p \$pid | wc -l\`" >>ircdchk
echo "if test \$running -gt 1" >>ircdchk
echo "then" >>ircdchk
echo "# It's still running, spit out the error message" >>ircdchk
echo "echo \"The ircd is still running, cowardly refusing reboot.\" >&5" >>ircdchk
echo "exit 0" >>ircdchk
echo "fi" >>ircdchk
echo "#" >>ircdchk
echo "# The process id file exists, but nothing is running with that pid" >>ircdchk
echo "# Therefore it's a stale pid file." >>ircdchk
echo "echo \"Stale ircd.pid file, erasing...\" >&5" >>ircdchk
echo "rm -f ircd.pid" >>ircdchk
echo "fi" >>ircdchk
echo "#" >>ircdchk
echo "# If we get here, that means the ircd is not running and must be started..." >>ircdchk
echo "cd \$prefix" >>ircdchk
echo "" >>ircdchk
echo "echo \"Restarting ircd-immortal...\" >&5" >>ircdchk
echo "./immortal" >>ircdchk
echo "" >>ircdchk
echo "exit 0" >>ircdchk
